<?php

/**
 *      This script handles the selection of images in album and online images.
 *      Local image upload is handled in uc_server/control/user.php/onuploadavatar
 */

if(!defined('IN_DISCUZ')) {
	exit('Access Denied');
}

if(empty($_G['uid'])) {
    exit(lang('message', 'not_loggedin'));
}

define('URL_ROOT', strtolower(($_SERVER['HTTPS'] == 'on' ? 'https' : 'http').'://'.$_SERVER['HTTP_HOST'].substr($_SERVER['PHP_SELF'], 0, strrpos($_SERVER['PHP_SELF'], '/'))));

if (submitcheck('formhash')) {
    if (submitcheck('imagesubmit')) {
        $imageurl = $_G['gp_image_url'];
    }
    elseif ($_G['gp_album_pic_url']) {
        $imageurl = $_G['gp_album_pic_url'];
        if (!preg_match('/^https?:\/\//is', $imageurl)) {
            $imageurl = URL_ROOT . '/' . $imageurl;
        }
    }
}

if ($imageurl) {
    if (0 === strpos($imageurl, URL_ROOT . '/')) {
        echo $imageurl;
        exit;
    }

    /* the following line is added to avoid the error "failed to open stream: HTTP request failed!"
     * when calling file_get_contents for resources on web servers that require user_agent in the request header
     * https://bugs.php.net/bug.php?id=22937#c64196
     * http://php.net/manual/en/function.fopen.php
     */
    ini_set('user_agent', $_SERVER['HTTP_USER_AGENT']);
    $data = file_get_contents($imageurl);
    if(!$data) {
        exit('Invalid Image Source');
    }
    $tmpfname = tempnam($_G['setting']['attachdir'].'./temp/', "AVT");
    if(!$tmpfname) {
        exit('Cannot create temp file');
    }
    @chmod($tmpfname, 0644);
    if (!file_put_contents($tmpfname, $data)) {
        exit('Unable to copy image');
    }
    list($width, $height, $type, $attr) = getimagesize($tmpfname);
    if(!in_array($type, array(1,2,3,6))) {
        exit('Invalid image type');
    }
    if($width < 10 || $height < 10 || $type == 4) {
        exit('Invalid file size');
    }
    $imgtype = array(1 => '.gif', 2 => '.jpg', 3 => '.png');
    $filetype = $imgtype[$type];
    if(!$filetype) $filetype = '.jpg';
    $tmpavatar = $_G['setting']['attachdir'].'./temp/upload'.$_G['uid'].$filetype;
    @rename($tmpfname, $tmpavatar);
    $avatarurl = URL_ROOT.'/'.$_G['setting']['attachurl'].'temp/upload'.$_G['uid'].$filetype;
    echo $avatarurl;
}
?>