<?php

/**
 *      This script generates avatar image data
 */

if(!defined('IN_DISCUZ')) {
	exit('Access Denied');
}
if(empty($_G['uid'])) {
    exit(lang('message', 'not_loggedin'));
}
$imageurl = $_G['gp_imageurl'];
$sl = $_G['gp_sl'];
$st = $_G['gp_st'];
$sw = $_G['gp_sw'];
$sh = $_G['gp_sh'];
$tw = $_G['gp_tw'];
$th = $_G['gp_th'];

/* the following line is added to avoid the error "failed to open stream: HTTP request failed!"
 * when calling file_get_contents for resources on web servers that require user_agent in the request header
 * https://bugs.php.net/bug.php?id=22937#c64196
 * http://php.net/manual/en/function.fopen.php
 */
ini_set('user_agent', $_SERVER['HTTP_USER_AGENT']);
$data = file_get_contents($imageurl);
if(!$data) {
    exit('Invalid Image Source');
}
$tmpfname = tempnam($_G['setting']['attachdir'].'./temp/', "AVT");
if(!$tmpfname) {
    exit('Cannot create temp file');
}
if (!file_put_contents($tmpfname, $data)) {
    exit('Unable to copy image');
}

// http://phpimageworkshop.com/tutorial/5/manage-animated-gif-with-imageworkshop.html
use PHPImageWorkshop\ImageWorkshop;
use GifFrameExtractor\GifFrameExtractor;
use GifCreator\GifCreator;
require_once 'res/PHPImageWorkshop/ImageWorkshop.php';
require_once 'res/GifFrameExtractor.php';
require_once 'res/GifCreator.php';

if (GifFrameExtractor::isAnimatedGif($tmpfname)) {
    $gfe = new GifFrameExtractor();
    $frames = $gfe->extract($tmpfname, true);
    $retouchedFrames = array();
    foreach ($frames as $frame) {
        $frameLayer = ImageWorkshop::initFromResourceVar($frame['image']);
        $frameLayer->cropInPixel($sw, $sh, $sl, $st, "LT");
        $frameLayer->resizeInPixel($tw, $th, true);
        $retouchedFrames[] = $frameLayer->getResult();
    }
    $gc = new GifCreator();
    $gc->create($retouchedFrames, $gfe->getFrameDurations(), 0);
    $data = $gc->getGif();
}
else {
    $layer = ImageWorkshop::initFromPath($tmpfname);
    $layer->cropInPixel($sw, $sh, $sl, $st, "LT");
    $layer->resizeInPixel($tw, $th, true);

    $target = uniqid(rand(), true).".png";
    $layer->save($_G['setting']['attachdir'].'./temp/', $target, false, null, 100);
    $data = file_get_contents($_G['setting']['attachdir'].'./temp/'.$target);
    @unlink($_G['setting']['attachdir'].'./temp/'.$target);
}
@unlink($tmpfname);

$base64 = base64_encode($data);
echo '<div>'.$base64.'</div>';
?>